function [F,A1,A2,B1m,B1l,B2m,B2l] = MDF_MF12(para,mature, rho_m,sig_m,delta0,delta1_m,A1_star,phi_star1m,phi_star11,phi_star1e,var_1,A2_star_,phi_star2m,phi_star22,H1,H1v,H2)
% LAST UPDATED 12/26/2009

[muQ, rhoQ, rho,sig, delta1] = para_vec2ind_MF12_17(para,mature,rho_m,sig_m,delta1_m);
para_str = para_ind2str_MF12(muQ, rhoQ, rho,sig, delta1, delta0);
[A1, A2, B1m,B1l,B2m,B2l] = ABdiff_MF12(para_str, mature) ;

N = 3;
rho_l = rho(end-N+1:end,end-N+1:end);
N_m = 2;

F = nan;
if nargin > 7
    if rcond(B1l)<1e-15
        F = 1e50;
    else                       
        temp1_l = A1_star;
        temp1_r = (A1 - B1l*rho_l/B1l*A1);
        temp2_l = phi_star1m;
        temp2_r = B1m*rho_m-B1l*rho_l/B1l*B1m;
        temp3_l = phi_star11; 
        temp3_r = B1l*rho_l/B1l;
        B1m_ = B1m(:,1:N_m);
        temp4_l = phi_star1e;
        temp4_r = B1m_;
        para1_l = [temp1_l';temp2_l';temp3_l';temp4_l'];
        para1_r = [temp1_r';temp2_r';temp3_r';temp4_r'];
        para1_diff = para1_l-para1_r;
        F1 = para1_diff(:)'*H1*para1_diff(:);
        
        temp5_l = var_1;
        temp5_r = (B1l*B1l');
        var1_diff = temp5_l-temp5_r;
        F1v = ltvec(var1_diff)'*H1v*ltvec(var1_diff);
                
        temp6_l = A2_star_; 
        temp6_r = A2 - B2l/B1l*A1;
        temp7_l = phi_star2m;
        temp7_r = B2m-B2l/B1l*B1m;
        temp8_l = phi_star22;
        temp8_r = B2l/B1l;
        
        para2_l = [temp6_l';temp7_l';temp8_l'];
        para2_r = [temp6_r';temp7_r';temp8_r'];
        para2_diff = para2_l-para2_r;
        F2 = para2_diff(:)'*H2*para2_diff(:);
        
        F = (F1+F1v+F2);
    end
end
