clear
clc

load mature;           
load APdata;

%% OLS
data.f_m(:,2) = -data.f_m(:,2);
f_m = data.f_m;
Y_1 = data.Y_1;
Y_2 = data.Y_2;
N = size(Y_1,2);
Ne = size(Y_2,2);
T = length(Y_1)-1;

Fm_tminus1  = [f_m(12:end-1,:),f_m(11:end-2,:),f_m(10:end-3,:),f_m(9:end-4,:),f_m(8:end-5,:),f_m(7:end-6,:),f_m(6:end-7,:),f_m(5:end-8,:),f_m(4:end-9,:),f_m(3:end-10,:),f_m(2:end-11,:),f_m(1:end-12,:)];
Fm_t        = [f_m(13:end,:),f_m(12:end-1,:),f_m(11:end-2,:),f_m(10:end-3,:),f_m(9:end-4,:),f_m(8:end-5,:),f_m(7:end-6,:),f_m(6:end-7,:),f_m(5:end-8,:),f_m(4:end-9,:),f_m(3:end-10,:),f_m(2:end-11,:)];


r_short = Y_1(2:end,1);
x  = [ones(T,1),f_m(13:end,:)];
para_r = x\r_short;
delta0 = para_r(1);
delta1_m = para_r(2:end);

ym  = f_m(13:end,:);
T = length(ym);
xm = Fm_tminus1;
param = xm\ym;
rho_m = [param';eye(22),zeros(22,2)];
umt_star = ym-xm*param;                                     %umt_star is T*2
var_m = var_OLS(umt_star);
sig_m = chol(var_m)';

y1 = Y_1(2:end,:);
x1 = [ones(T,1),Fm_tminus1,Y_1(1:end-1,:),umt_star];
para1 = x1\y1;
A1_star  = para1(1,:)';
phi_star1m = para1(2:25,:)';
phi_star11 = para1(26:28,:)';
phi_star1e = para1(29:end,:)';
u1t_star = y1 - x1*para1;
var_1 = var_OLS(u1t_star);

y2 = Y_2(2:end,:);
x2 = [ones(T,1),Fm_t,Y_1(2:end,:)];
para2 = x2\y2;
A2_star_ = para2(1,:)';
phi_star2m = para2(2:25,:)';
phi_star22 = para2(26:end,:)';                          
u2t_star = y2 - x2*para2;
var_2 = var_OLS(u2t_star);

%% calculate Hessian

H1 = kron(inv(var_1),x1'*x1);
d = duplication(size(var_1,1));
H1v = T/2*d'*kron(inv(var_1),inv(var_1))*d;
H2 = kron(inv(var_2),x2'*x2);

%% 100 round MD estimation with random starting values
options  =  optimset('fminunc');
options  =  optimset(options , 'TolFun'      , 1e-20);
options  =  optimset(options , 'TolX'      , 1e-15);
options  =  optimset(options , 'Display'     , 'iter');
options  =  optimset(options , 'Diagnostics' , 'on');
options  =  optimset(options , 'LargeScale'  , 'off');
options  =  optimset(options , 'MaxIter' , 5000) ;
options  =  optimset(options , 'MaxFunEvals' , 50000) ;

n = 100;
MDFv = zeros(n,1);
delta1_l = ones(3,1)*1e-4;

for i=1:n
    rho_l = diag(sort(rand(3,1)/2+0.5,1,'descend'));    
    rho = blkdiag(rho_m,rho_l);
    rhoQ = rho;
    muQ = zeros(5,1);
    parameters = para_ind2vec_MF12_17(muQ, rhoQ, rho, delta1_l);

    for j = 1:10
        initial = parameters;
        [parameters,MDF] =  fminunc('MDF_MF12',initial, options,mature,rho_m,sig_m,delta0,delta1_m,A1_star,phi_star1m,phi_star11,phi_star1e,var_1,A2_star_,phi_star2m,phi_star22,H1,H1v,H2);
    end
    [muQ, rhoQ, rho,sig, delta1] = para_vec2ind_MF12_17(parameters,mature,rho_m,sig_m,delta1_m);
    MDFv(i) = MDF;
    %save (sprintf('result_%d',i),'rho','delta1','muQ','rhoQ','MDF','parameters');      
end
%save MDF MDFv
