function [muQ, rhoQ, rho,sig, delta1] = para_vec2ind_MF12_17(para,mature,rho_m,sig_m,delta1_m)   
% para_vec2ind_MF1 passes values from the vector 'para' to individual
% parameters for the MF1 model
%
% INPUTS:   para:   the vector of parameters containg all info and used as a
%                   companion form for estimation purpose et al.
% OUTPUTS:  muQ, rhoQ, rho,sig, delta1: parameters from no arbitrage
%           structure
% last updated 04/15/2010

N = length(mature.exact);                                                  
N_m = 2;
N_lag = 12;

nn = N;
delta1_l   = para(1: nn)/1e3;
delta1 = [delta1_m;zeros((N_lag-1)*N_m,1);delta1_l];
nn_ = nn + N_m*N_m;
rhoQ_m = reshape(para(nn+1:nn_),N_m,N_m);
nn = nn_+ 5;
rhoQ_l = zeros(N);
rhoQ_l(:,1) =  para(nn_+1:nn_+3);
rhoQ_l(2:3,3) =  para(nn_+4:nn);

nn_ = nn + 4;
rho_l = zeros(N);
rho_l(1,1) = para(nn+1);
rho_l(2:3,2) = para(nn+2:nn+3);
rho_l(3,3) = para(nn_);
rho = blkdiag(rho_m,rho_l);

rhoQ_l (:,2) = rho_l (:,2);
rhoQ_l (1,3) = rho_l (1,3);
rhoQ = blkdiag(rho_m,rhoQ_l);
rhoQ(1:N_m,1:N_m) = rhoQ_m;

muQ = zeros(27,1);
muQ(end-2) = para(nn_+1);

sig = zeros(N_m*N_lag+N);
sig(1:N_m,1:N_m) = sig_m;
sig(end-N+1:end,end-N+1:end) = eye(3);


